lib/: spdx license conversion
[xfstests-dev.git] / tests / generic / 112
1 #! /bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 # Copyright (c) 2005 Silicon Graphics, Inc.  All Rights Reserved.
4 #
5 # FS QA Test No. 112
6 #
7 # fsx (AIO variant, based on 075)
8 #
9 seq=`basename $0`
10 seqres=$RESULT_DIR/$seq
11 echo "QA output created by $seq"
12
13 here=`pwd`
14 tmp=/tmp/$$
15 status=0        # success is the default!
16 trap "_cleanup; exit \$status" 0 1 2 3 15
17
18 _cleanup()
19 {
20     cd /
21     rm -rf $TEST_DIR/fsx.* $tmp.*
22 }
23
24 # get standard environment, filters and checks
25 . ./common/rc
26 . ./common/filter
27
28 _do_test()
29 {
30     _n="$1"
31     _param="$2"
32
33     out=$TEST_DIR/fsx
34     rm -rf $out
35     if ! mkdir $out
36     then
37         echo "    failed to mkdir $out"
38         status=1
39         exit
40     fi
41
42     _filter_param=`echo "$_param" | sed\
43         -e 's/-N [0-9][0-9]*/-N numops/' \
44         -e 's/-l [0-9][0-9]*/-l filelen/'`
45
46     echo ""
47     echo "-----------------------------------------------"
48     echo "fsx.$_n : $_filter_param"
49     echo "-----------------------------------------------"
50
51     if [ "$FSTYP" != "xfs" ]
52     then
53         if [ "$_n" = "1" -o "$_n" = "3" ]
54         then
55             # HACK: only xfs handles preallocation (-x) so just skip this test
56             return
57         fi
58     fi
59
60     # This cd and use of -P gets full debug on $here (not TEST_DEV)
61     cd $out
62     if ! $here/ltp/fsx $_param -P $here $FSX_AVOID $seq.$_n &>/dev/null
63     then
64         echo "    fsx ($_param) returned $? - see $seq.$_n.full"
65         mv $here/$seq.$_n.fsxlog $seqres.$_n.full
66         status=1
67         exit
68     fi
69
70     cd $here
71     _check_test_fs
72 }
73
74 _usage()
75 {
76     echo "$0: [-l filelen] [-n numops1] [-N numops2]"
77 }
78
79 _process_args()
80 {
81     OPTIND=1
82     while getopts "l:n:N:?" c $@
83     do
84         case $c
85         in
86             l)
87                 filelen=$OPTARG
88                 param_type="$param_type, overidde -l"
89                 ;;
90             N)
91                 numops2=$OPTARG
92                 param_type="$param_type, overidde -N"
93                 ;;
94             n)
95                 numops1=$OPTARG
96                 param_type="$param_type, overidde -n"
97                 ;;
98             ?)
99                 _usage
100                 exit    
101                 ;;
102         esac
103     done
104 }
105
106 # real QA test starts here
107 _supported_fs generic
108 _supported_os Linux
109 _require_test
110 _require_aio
111
112 [ -x $here/ltp/aio-stress ] || \
113         _notrun "fsx not built with AIO for this platform"
114
115 size10=`expr 10 \* 1024 \* 1024`        # 10 megabytes
116 filelen=$size10
117 numops1=1000
118 numops2=10000
119
120 # can override the params here
121 _process_args "$@"
122
123 echo "Params are for $param_type" >>$seqres.full
124 echo "Params: n = $numops1 N = $numops2 l = $filelen" >>$seqres.full
125
126 rm -f $seqres.full
127 echo "brevity is wit..."
128
129 _check_test_fs
130
131 # Options:
132 # -d: debug output for all operations
133 # -l flen: the upper bound on file size (default 262144)
134 # -o oplen: the upper bound on operation size
135 # -N numops: total # operations to do (default infinity)
136 # -P: save .fsxlog and .fsxgood files in dirpath (default ./)
137 # -S seed: for random # generator (default 1) 0 gets timestamp
138 # -x: pre-allocate file space, exercising unwritten extents
139 # -A: use the AIO system calls
140
141 _do_test 0 "-A -d -N $numops1 -S 0"
142 _do_test 1 "-A -d -N $numops1 -S 0 -x"
143 _do_test 2 "-A -d -N $numops2 -l $filelen -S 0"
144 _do_test 3 "-A -d -N $numops2 -l $filelen -S 0 -x"
145
146 rm -f $seq.*.fsx{good,log}
147 exit 0